#include <QCoreApplication>
#include <QImage>
#include <QtSvg/QSvgRenderer>
#include <QPainter>
#include <QtCore/QtDebug>

int main( int argc, char **argv )
{
	QCoreApplication app( argc, argv );
	QStringList arguments = QCoreApplication::arguments();
	if (arguments.size() != 5) {
		qDebug() << "\
qsvg2png converts a svg or svgz vector image into png raster image\n \
qsvg2png needs 4 arguments:\n \
width: \twidth of the png image\n \
height:\theight of the png image\n \
src:   \tfilename of the source svg/svgz image\n \
dest:  \tfilename of the converted png image\n";
		return(-1);
	}

	QSvgRenderer *renderer = new QSvgRenderer;
	if (renderer->QSvgRenderer::load(arguments.at(3))) {
		QImage image(arguments.at(1).toInt(), arguments.at(2).toInt(), QImage::Format_ARGB32_Premultiplied);
		image.fill(0);
		QPainter painter(&image);
		renderer->QSvgRenderer::render(&painter);
		image.save(arguments.at(4), "PNG",-1); // writes image in PNG format
		delete renderer;
		return(0);
	}
	else {
		delete renderer;
	       	return(-1);
	}
}
